      *********************************************************************
      * MODULE NAME:       FAAPLTPI.CCP                                   *
      *                    modified by Marta Wojnar, IBM Germany          *
      *                    (helped by Tom Grieve, IBM Hursley)            *
      * FUNCTION:        - allocate shared memory                         *
      *                  - DPL to a host routine for name of this server  *
      *                  - save the server name in the shared memory      *
      *                  - when host not active                           *
      *                    - free allocated memory                        *
      *                    - shutdown CICS OS/2                           *
      * STATUS:                                                           *
      *  24 July 1995     Version 3 Release 0                             *
      *                                                                   *
      *********************************************************************
      *
       IDENTIFICATION DIVISION.
       PROGRAM-ID. FAAPLTPI.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01 CA.
          02 CNAME       PIC X(4)          VALUE SPACES.
       01 CAL            PIC S9(4) COMP-5  VALUE 4.
       01 WORK1.
          02 MESSAGE-1   PIC X(26) VALUE 'PLTPI processing complete.'.
          02 MESSAGE-2.
             03 MSG-2    PIC X(21) VALUE 'PLTPI - ALLOC failed:'.
             03 MSGRC    PIC 9(5)  VALUE 0.
          02 MESSAGE-3   PIC X(26) VALUE 'PLTPI - Host not active.'.
          02 MESSAGE-4   PIC X(26) VALUE 'PLTPI - PPT entry missing.'.
      *   Read, Write, Execute, Commit & Tiled Flags, byte-swapped
      *   compared to what is described in OS/2 Reference
       01 WS-ALLNMEMF PIC X(4)  VALUE X'57000000'.
       01 WS-ALLNMEMR REDEFINES WS-ALLNMEMF PIC 9(8) COMP-5.
       01 WS-MEMADDR  POINTER.
       01 WS-MEMSIZE  PIC 9(8)  COMP-5  VALUE 4096.
       01 WS-RETCODE  PIC 9(8)  COMP-5.
       01 WS-MEMNAME.
          02 FILLER   PIC X(15)         VALUE '\SHAREMEM\MWVDV'.
          02 FILLER   PIC X             VALUE X'00'.
       LINKAGE SECTION.
       01  DFHCOMMAREA              PIC X.
       01  SHRMEM.
           02 SCNAME                PIC X(4).
       PROCEDURE DIVISION.
       B1-BEGIN.
               CALL 'DosAllocSharedMem' USING
                    BY REFERENCE WS-MEMADDR
                    BY REFERENCE WS-MEMNAME
                    BY VALUE     WS-MEMSIZE
                    BY VALUE     WS-ALLNMEMR
                    RETURNING    WS-RETCODE
               END-CALL
               IF WS-RETCODE NOT = 0
                  MOVE WS-RETCODE TO MSGRC
                  EXEC CICS WRITE OPERATOR
                       TEXT(MESSAGE-2)
                       TEXTLENGTH(26)
                       NOHANDLE
                  END-EXEC
                  GO TO FEHL-E
               END-IF.
               SET ADDRESS OF SHRMEM TO WS-MEMADDR.
               EXEC CICS HANDLE CONDITION SYSIDERR(FEHL) TERMERR(FEHL)
                                          PGMIDERR(FEHLT)
               END-EXEC.
      *
      * DPL to a host program getting the server's terminal id by using
      *    EXEC CICS ASSIGN PRINSYSID(...)
      *
               EXEC CICS LINK PROGRAM('MWVDV') COMMAREA(CA) LENGTH(CAL)
               END-EXEC.
               IF CNAME = SPACES
                    GO TO FEHL
               END-IF.
               MOVE CNAME TO SCNAME.
               EXEC CICS WRITE OPERATOR
                    TEXT(MESSAGE-1)
                    TEXTLENGTH(26)
                    NOHANDLE
               END-EXEC.
               EXEC CICS WRITE OPERATOR
                    TEXT(CNAME)
                    TEXTLENGTH(4)
                    NOHANDLE
               END-EXEC.
       B1.     EXEC CICS XCTL
                    PROGRAM('FAAOIS04')
               END-EXEC.
       B1-EXIT. EXIT.
       FEHL.
               EXEC CICS WRITE OPERATOR
                    TEXT(MESSAGE-3)
                    TEXTLENGTH(26)
                    NOHANDLE
               END-EXEC.
               GO TO FEHLX.
       FEHLT.
               EXEC CICS WRITE OPERATOR
                    TEXT(MESSAGE-4)
                    TEXTLENGTH(26)
                    NOHANDLE
               END-EXEC.
       FEHLX.
               CALL 'DosFreeMem' USING
                    BY VALUE WS-MEMADDR
               END-CALL.
       FEHL-E.
               EXEC CICS PERFORM SHUTDOWN
               END-EXEC.
               EXEC CICS RETURN
               END-EXEC.
               EXIT.
