      *********************************************************************
      * MODULE NAME:       FAAEXP01.CBL                                   *
      *                    modified by Marta Wojnar, IBM Germany          *
      * FUNCTION:        - get server name from the shared memory         *
      *                  - rename V123/V124 to XXV3/XXV4 and              *
      *                    C0nn to XXnn, where XX are the first two chars *
      *                    of the server terminal-id in host CICS         *
      * STATUS:                                                           *
      *  11 January 1995  Version 2 Release 0                             *
      *                                                                   *
      *********************************************************************
        ENVIRONMENT DIVISION.
        SPECIAL-NAMES.
        CALL-CONVENTION 3 IS OS2API.
        DATA DIVISION.
      *
        WORKING-STORAGE SECTION.
        77 WNAME                              PIC X(2) VALUE 'XX'.
        01 MEMNAME.
           02 FILLER      PIC X(19)         VALUE '\SHAREMEM\VDVSEG'.
           02 FILLER      PIC X             VALUE X'00'.
        01 SHARED-BUFFER-PTR.
           02 BUFFER-OFF  PIC 9(4)  COMP-5  VALUE 0.
           02 BUFFER-SEG  PIC 9(4)  COMP-5.
        01 SBUFFER-PTR    REDEFINES SHARED-BUFFER-PTR USAGE POINTER.
      *
        LINKAGE SECTION.
        COPY FAAEXW01.
        01 EXIT-01-TERMINAL-NAME                           PIC X(4).
        01  SHRMEM.
            02 SCNAME                PIC X(4).
      *
        PROCEDURE DIVISION USING EXIT-01-BLOCK.
      *
        B1-BEGIN SECTION.
      *
           IF WNAME = 'XX'
              CALL OS2API '__DOSGETSHRSEG' USING
                   BY REFERENCE MEMNAME
                   BY REFERENCE BUFFER-SEG
              END-CALL
              IF RETURN-CODE NOT = 0
                 GO TO B1-EXIT
              END-IF
              MOVE 0 TO BUFFER-OFF
              SET ADDRESS OF SHRMEM TO SBUFFER-PTR
              MOVE SCNAME TO WNAME
           END-IF
      *
           SET  ADDRESS OF EXIT-01-TERMINAL-NAME
             TO EXIT-01-TERMINAL-NAME-POINTER
           IF EXIT-01-CHANGE-NAME-OUTBOUND
      *       - Change the first two bytes to connection name,
      *         for V123 and V124 change third byte to V
              IF EXIT-01-TERMINAL-NAME(1:2) = 'V1'
                 MOVE 'V' TO EXIT-01-TERMINAL-NAME(3:1)
              END-IF
              MOVE WNAME TO EXIT-01-TERMINAL-NAME(1:2)
           ELSE
      *
      *        - Change the name back
               IF EXIT-01-TERMINAL-NAME(1:2) = WNAME
                  IF EXIT-01-TERMINAL-NAME(3:1) = 'V'
                     MOVE 'V12' TO EXIT-01-TERMINAL-NAME(1:3)
                  ELSE
                     MOVE 'C0' TO EXIT-01-TERMINAL-NAME(1:2)
                  END-IF
               END-IF
           END-IF
           .
        B1-EXIT. GOBACK.
