      *********************************************************************
      * MODULE NAME:       FAAPLTPI.CCP                                   *
      *                    modified by Marta Wojnar, IBM Germany          *
      * FUNCTION:        - allocate shared memory                         *
      *                  - DPL to a host routine for name of this server  *
      *                  - save the server name in the shared memory      *
      *                  - when host not active                           *
      *                    - free allocated memory                        *
      *                    - shutdown CICS OS/2                           *
      * STATUS:                                                           *
      *  11 January 1995  Version 2 Release 0                             *
      *                                                                   *
      *********************************************************************
      *
        IDENTIFICATION DIVISION.
        PROGRAM-ID. FAAPLTPI.
        ENVIRONMENT DIVISION.
        SPECIAL-NAMES.
        CALL-CONVENTION 3 IS OS2API.
        DATA DIVISION.
        WORKING-STORAGE SECTION.
        01 CA.
           02 CNAME       PIC X(4)          VALUE SPACES.
        01 CAL            PIC S9(4) COMP-5  VALUE 4.
        01 WORK1.
           02 MESSAGE-1   PIC X(26) VALUE 'PLTPI processing complete.'.
           02 MESSAGE-2   PIC X(26) VALUE 'PLTPI - ALLOC failed.'.
           02 MESSAGE-3   PIC X(26) VALUE 'PLTPI - Host not active.'.
        01 WS-AREA.
           02 WS-MEMSIZE PIC S9(9) COMP-5  VALUE 4096.
           02 WS-MEMNAME.
              03 FILLER   PIC X(19)         VALUE '\SHAREMEM\VDVSEG'.
              03 FILLER   PIC X             VALUE X'00'.
        01 SHARED-BUFFER-PTR.
           02 BUFFER-OFF  PIC 9(4)  COMP-5  VALUE 0.
           02 BUFFER-SEG  PIC 9(4)  COMP-5.
        01 SBUFFER-PTR    REDEFINES SHARED-BUFFER-PTR USAGE POINTER.
        LINKAGE SECTION.
        01  DFHCOMMAREA              PIC X.
        01  SHRMEM.
            02 SCNAME                PIC X(4).
        PROCEDURE DIVISION.
        B1-BEGIN.
                CALL OS2API '__DOSALLOCSHRSEG' USING
                     BY VALUE     WS-MEMSIZE
                     BY REFERENCE WS-MEMNAME
                     BY REFERENCE BUFFER-SEG.
                IF RETURN-CODE NOT = 0
                   EXEC CICS WRITE OPERATOR
                        TEXT(MESSAGE-2)
                        TEXTLENGTH(26)
                        NOHANDLE
                   END-EXEC
                   GO TO FEHL-E
                END-IF.
                MOVE 0 TO BUFFER-OFF.
                SET ADDRESS OF SHRMEM TO SBUFFER-PTR.
                EXEC CICS HANDLE CONDITION SYSIDERR(FEHL) TERMERR(FEHL)
                END-EXEC.
      *
      * DPL to a host program getting the server's terminal id by using
      *     EXEC CICS ASSIGN PRINSYSID(...)
      *
                EXEC CICS LINK PROGRAM('MWVDV') COMMAREA(CA) LENGTH(CAL)
                END-EXEC.
                IF CNAME = SPACES
                     GO TO FEHL
                END-IF.
                MOVE CNAME TO SCNAME.
                EXEC CICS WRITE OPERATOR
                     TEXT(MESSAGE-1)
                     TEXTLENGTH(26)
                     NOHANDLE
                END-EXEC.
                EXEC CICS WRITE OPERATOR
                     TEXT(CNAME)
                     TEXTLENGTH(4)
                     NOHANDLE
                END-EXEC.
        B1.     EXEC CICS XCTL
                   PROGRAM('FAAOIS04')
                END-EXEC.
        B1-EXIT. EXIT.
        FEHL.
                EXEC CICS WRITE OPERATOR
                     TEXT(MESSAGE-3)
                     TEXTLENGTH(26)
                     NOHANDLE
                END-EXEC.
                CALL OS2API '__DOSFREESEG' USING
                     BY REFERENCE BUFFER-SEG.
        FEHL-E.
                EXEC CICS PERFORM SHUTDOWN
                END-EXEC.
                EXEC CICS RETURN
                END-EXEC.
                EXIT.
